#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>

#define ERROR_OUTPUT stderr
#define ASSERT(b) {if (!(b)) {fprintf(ERROR_OUTPUT, "ASSERT failed on line %d, file %s.\n", __LINE__, __FILE__); exit(1);}}

typedef struct _PointT {
  int index; // the index of this point in the dataset list of points
  float *coordinates;
  int tag;
} PointT, *PPointT;

typedef struct _ERRINDEX{
	float data1;
	float data2;
	float error;
	int index;
}ERRINDEX, *PERRINDEX;

// Generate a random real distributed uniformly in [rangeStart,
// rangeEnd]. Input must satisfy: rangeStart <= rangeEnd. The
// granularity of generated random reals is given by RAND_MAX.
float genUniformRandom(float rangeStart, float rangeEnd){
  ASSERT(rangeStart <= rangeEnd);
  float r;
  r = rangeStart + ((rangeEnd - rangeStart) * (float)random() / (float)RAND_MAX);
  ASSERT(r >= rangeStart && r <= rangeEnd);
  return r;
}

// Generate a random 32-bits unsigned (int) in the range
// [rangeStart, rangeEnd]. Inputs must satisfy: rangeStart <=
// rangeEnd.
int genRandomUns32(int rangeStart, int rangeEnd){
  ASSERT(rangeStart <= rangeEnd);
  int r;
  if (RAND_MAX >= rangeEnd - rangeStart) {
    r = rangeStart + (int)((rangeEnd - rangeStart + 1.0) * random() / (RAND_MAX + 1.0));
  } else {
    r = rangeStart + (int)((rangeEnd - rangeStart + 1.0) * ((long int)random() * ((long int)RAND_MAX + 1) + (long int)random()) / ((long int)RAND_MAX * ((long int)RAND_MAX + 1) + (long int)RAND_MAX + 1.0));
  }
  ASSERT(r >= rangeStart && r <= rangeEnd);
  return r;
}

void usage(char *programName){
  printf("Usage: %s kde_from_allpts kde_from_sample #pts_in_test_file k\n", programName);
}

void readDataSetFromFile(char *filename, float* dataSetPoints, int d,int nPoints){
  FILE *f = fopen(filename, "rt");
  for(int i = 0; i < nPoints; i++){
    for(int j = 0; j < d; j++){
         int dummy = fscanf(f, "%f", &(dataSetPoints[i*d+j]));
    }
  }
  fclose(f);
}

int main(int nargs, char **args){


	if(nargs < 4){
        usage(args[0]);
		exit(1);
    }

	srand(time(0));
	FILE* fpin1 = fopen(args[1],"r");
	FILE* fpin2 = fopen(args[2],"r");
	float *pTargets;
	
	int nPoints = atoi(args[4]);

	int dim = atoi(args[5]);
	int k = atoi(args[6]);

	float data1 = 0;
	float data2 = 0;
	char str [80];
	float sum = 0;
	float diff = 0;

	pTargets = new float[nPoints*dim];
	readDataSetFromFile(args[3],pTargets,dim,nPoints);

	for(int i = 0; i<nPoints; i++){
		int dummy = fscanf(fpin1, "%f", &(data1));
		int dummy2 = fscanf(fpin2, "%f",&(data2));
		diff = fabs(data1-data2);///((data1>data2)?data1:data2);
		sum += diff;

	}
	sum = sum/nPoints;
	printf("%f\n",sum);
	fclose(fpin1);
	fclose(fpin2);

}
